/*
 * This file is generated by jOOQ.
 */
package be.lghs.accounting.model.tables;


import be.lghs.accounting.model.Accounting;
import be.lghs.accounting.model.Keys;
import be.lghs.accounting.model.tables.records.MovementCategoriesRecord;

import java.util.Arrays;
import java.util.List;
import java.util.UUID;

import javax.annotation.processing.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Row4;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.14.9",
        "schema version:accounting_0010"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class MovementCategories extends TableImpl<MovementCategoriesRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>accounting.movement_categories</code>
     */
    public static final MovementCategories MOVEMENT_CATEGORIES = new MovementCategories();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<MovementCategoriesRecord> getRecordType() {
        return MovementCategoriesRecord.class;
    }

    /**
     * The column <code>accounting.movement_categories.id</code>.
     */
    public final TableField<MovementCategoriesRecord, UUID> ID = createField(DSL.name("id"), SQLDataType.UUID.nullable(false).defaultValue(DSL.field("uuid_generate_v4()", SQLDataType.UUID)), this, "");

    /**
     * The column <code>accounting.movement_categories.name</code>.
     */
    public final TableField<MovementCategoriesRecord, String> NAME = createField(DSL.name("name"), SQLDataType.VARCHAR(255).nullable(false), this, "");

    /**
     * The column <code>accounting.movement_categories.description</code>.
     */
    public final TableField<MovementCategoriesRecord, String> DESCRIPTION = createField(DSL.name("description"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>accounting.movement_categories.type</code>.
     */
    public final TableField<MovementCategoriesRecord, String> TYPE = createField(DSL.name("type"), SQLDataType.VARCHAR(255).nullable(false), this, "");

    private MovementCategories(Name alias, Table<MovementCategoriesRecord> aliased) {
        this(alias, aliased, null);
    }

    private MovementCategories(Name alias, Table<MovementCategoriesRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>accounting.movement_categories</code> table reference
     */
    public MovementCategories(String alias) {
        this(DSL.name(alias), MOVEMENT_CATEGORIES);
    }

    /**
     * Create an aliased <code>accounting.movement_categories</code> table reference
     */
    public MovementCategories(Name alias) {
        this(alias, MOVEMENT_CATEGORIES);
    }

    /**
     * Create a <code>accounting.movement_categories</code> table reference
     */
    public MovementCategories() {
        this(DSL.name("movement_categories"), null);
    }

    public <O extends Record> MovementCategories(Table<O> child, ForeignKey<O, MovementCategoriesRecord> key) {
        super(child, key, MOVEMENT_CATEGORIES);
    }

    @Override
    public Schema getSchema() {
        return Accounting.ACCOUNTING;
    }

    @Override
    public UniqueKey<MovementCategoriesRecord> getPrimaryKey() {
        return Keys.MOVEMENT_CATEGORIES_PKEY;
    }

    @Override
    public List<UniqueKey<MovementCategoriesRecord>> getKeys() {
        return Arrays.<UniqueKey<MovementCategoriesRecord>>asList(Keys.MOVEMENT_CATEGORIES_PKEY);
    }

    @Override
    public MovementCategories as(String alias) {
        return new MovementCategories(DSL.name(alias), this);
    }

    @Override
    public MovementCategories as(Name alias) {
        return new MovementCategories(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public MovementCategories rename(String name) {
        return new MovementCategories(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public MovementCategories rename(Name name) {
        return new MovementCategories(name, null);
    }

    // -------------------------------------------------------------------------
    // Row4 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row4<UUID, String, String, String> fieldsRow() {
        return (Row4) super.fieldsRow();
    }
}
